package calculus;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.SortedMap;

import algebra.linear.Sum;
import algebra.numbers.Rational;
import algebra.words.Alphabet;
import algebra.words.Word;

/**
 * @author Anton Mellit
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class WordSum extends Sum {

	/**
	 * Constructor for WordSum.
	 */
	public WordSum() {
		super();
	}
	
	public void add(WordSum s, Word left, Word right, Rational r) {
		for(Iterator i = s.map.entrySet().iterator(); i.hasNext();) {
			Map.Entry entry = (Map.Entry) i.next();
			Word w = ((Word) entry.getKey()).multiply(left, right);
			add(w, r.multiply((Rational) entry.getValue()));
		}
	}
	
	public boolean reduce(WordSum s) {
		Word main = (Word) s.getMainObject();
		Rational k = s.getKoeff(main).invert().multiply(-1);
		SortedMap smallWords = map;
		boolean changed = false;
		while(!smallWords.isEmpty()) {
			Word w = (Word) smallWords.lastKey();
			if(w.compareTo(main)<0) {
				break;
			}
			int pos = w.find(main, 0);
			if(pos>=0) {
				changed = true;
				Word[] lr = w.divide(main, pos);
				add(s, lr[0], lr[1], k.multiply((Rational) smallWords.get(w)));
			} else {
				
			}
			smallWords = map.headMap(w);
		}
		return changed;
	}
	
	/**
	 * Relations must have main koefficient 1
	 */
	public boolean reduce(Collection relations) {
		SortedMap smallWords = map;
		boolean changed = false;
		while(!smallWords.isEmpty()) {
			Word w = (Word) smallWords.lastKey();
			for(Iterator i = relations.iterator(); i.hasNext(); ) {
				WordSum s = (WordSum) i.next();
				Word main = (Word) s.getMainObject();
				int pos = w.find(main, 0);
				if(pos>=0) {
					changed = true;
					Word[] lr = w.divide(main, pos);
					add(s, lr[0], lr[1], ((Rational) smallWords.get(w)).multiply(-1));
					break;
				}
			}
			smallWords = map.headMap(w);
		}
		return changed;
	}		

    public void parseString(String str, Alphabet abc) {
    	setZero();
    	int pos = 0;
    	while(pos<str.length()) {
    		boolean minus = false;
    		while(pos<str.length() && (str.charAt(pos)==' ' || 
    			str.charAt(pos)=='-' ||	str.charAt(pos)=='+')) {
    				if(str.charAt(pos)=='-') {
    					minus = true;
    				}
    				pos++;
    		}
    		if(pos==str.length()) {
    			break;
    		}
    		int pos1 = pos;
    		while(pos<str.length() && 
    			((str.charAt(pos)>='0' && str.charAt(pos)<='9') || str.charAt(pos)=='/')) {
    				pos++;
    		}
    		Rational k = Rational.ONE;
    		if(pos1<pos) {
    			k = Rational.parse(str.substring(pos1, pos));
    		}
    		if(minus) {
    			k = k.multiply(-1);
    		}
    		pos1 = pos;
    		while(pos<str.length() && str.charAt(pos)!='+' && str.charAt(pos)!='-') {
    			pos++;
    		}
    		add(Word.parseString(str.substring(pos1, pos), abc), k);
    	}
    }
    public static WordSum parse(String str, Alphabet abc) {
    	WordSum s = new WordSum();
    	s.parseString(str, abc);
    	return s;
    }
}
